<!-- Generated by documentation.js. Update this documentation by updating the source code. -->

### Table of Contents

-   [generateContribution][1]
    -   [Parameters][2]
-   [generateZeroContribution][3]
    -   [Parameters][4]
-   [addContributionShares][5]
    -   [Parameters][6]
-   [verifyContributionShare][7]
    -   [Parameters][8]
-   [addVerificationVectors][9]
    -   [Parameters][10]

## generateContribution

[index.js:10-40][11]

generates a members contribution to the DKG

### Parameters

-   `bls` **[Object][12]** an instance of [bls-wasm][13]
-   `ids` **[Array][14]&lt;[Number][15]>** an array of pointers containing the ids of the members of the groups
-   `threshold` **[Number][15]** the threshold number of members needed to sign on a message to
    produce the groups signature

Returns **[Object][12]** the object contains `verificationVector` which is an array of public key pointers
and `secretKeyContribution` which is an array of secret key pointers

## generateZeroContribution

[index.js:51-90][16]

generates a members contribution to the DKG, ensuring the secret is null

### Parameters

-   `bls` **[Object][12]** an instance of [bls-wasm][13]
-   `ids` **[Array][14]&lt;[Number][15]>** an array of pointers containing the ids of the members of the groups
-   `threshold` **[Number][15]** the threshold number of members needed to sign on a message to
    produce the groups signature

Returns **[Object][12]** the object contains `verificationVector` which is an array of public key pointers
and `secretKeyContribution` which is an array of secret key pointers

## addContributionShares

[index.js:97-104][17]

Adds secret key contribution together to produce a single secret key

### Parameters

-   `secretKeyShares` **[Array][14]&lt;[Number][15]>** an array of pointer to secret keys to add

Returns **[Number][15]** a pointer to the resulting secret key

## verifyContributionShare

[index.js:115-127][18]

Verifies a contribution share

### Parameters

-   `bls` **[Object][12]** an instance of [bls-wasm][13]
-   `id` **[Number][15]** a pointer to the id of the member verifiing the contribution
-   `contribution` **[Number][15]** a pointer to the secret key contribution
-   `vvec` **[Array][14]&lt;[Number][15]>** an array of pointers to public keys which is
    the verification vector of the sender of the contribution

Returns **[Boolean][19]** 

## addVerificationVectors

[index.js:133-147][20]

Adds an array of verification vectors together to produce the groups verification vector

### Parameters

-   `vvecs` **[Array][14]&lt;[Array][14]&lt;[Number][15]>>** an array containing all the groups verifciation vectors

[1]: #generatecontribution

[2]: #parameters

[3]: #generatezerocontribution

[4]: #parameters-1

[5]: #addcontributionshares

[6]: #parameters-2

[7]: #verifycontributionshare

[8]: #parameters-3

[9]: #addverificationvectors

[10]: #parameters-4

[11]: https://github.com/dfinity/dkg/blob/ec33c667b414083082e10d365ac8724296822968/index.js#L10-L40 "Source code on GitHub"

[12]: https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/Object

[13]: https://github.com/herumi/bls-wasm

[14]: https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/Array

[15]: https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/Number

[16]: https://github.com/dfinity/dkg/blob/ec33c667b414083082e10d365ac8724296822968/index.js#L51-L90 "Source code on GitHub"

[17]: https://github.com/dfinity/dkg/blob/ec33c667b414083082e10d365ac8724296822968/index.js#L97-L104 "Source code on GitHub"

[18]: https://github.com/dfinity/dkg/blob/ec33c667b414083082e10d365ac8724296822968/index.js#L115-L127 "Source code on GitHub"

[19]: https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/Boolean

[20]: https://github.com/dfinity/dkg/blob/ec33c667b414083082e10d365ac8724296822968/index.js#L133-L147 "Source code on GitHub"
